<template>
  <div class="t-input">
    <input
      :placeholder="placeholder"
      v-model="inner_value"
      :required="required"
      :disabled="disabled"
      :pattern="maskPattern(mask)"
      v-mask="maskValue(mask)"
      :title="maskValue(mask)"
      aria-label="3-digit prefix"
      :type="type"
      :input-mode="type === 'number' ? 'numeric' : ''"
      :style="{ color: disabled === '' ? '#aaa' : '' }"
    />
    <i
      v-if="inner_value.length && disabled === false"
      @click="handleClear()"
      class="bx bx-x"
    ></i>
  </div>
</template>

<script>
export default {
  props: {
    value: {
      default: "",
    },
    placeholder: {
      default: "",
      type: String,
    },
    required: {
      default: false,
    },
    disabled: {
      default: false,
    },
    mask: {
      default: false,
    },
    type: {
      default: false,
    },
  },
  data() {
    return {
      inner_value: this.value,
    };
  },
  watch: {
    inner_value() {
      this.$emit("input", this.inner_value);
    },
    value() {
      this.inner_value = this.value;
    },
  },
  computed: {
    maskPattern() {
      return (value) => {
        if (value === "phone") {
          return "[+][0-9]{3}[ ][(][0-9]{3}[)][-][0-9]{2}[-][0-9]{2}[-][0-9]{2}";
        }
        if (value === "bday") {
          return "[0-9]{2}[.][0-9]{2}[.][0-9]{4}";
        }
      };
    },
    maskValue() {
      return (value) => {
        if (value === "phone") {
          return "+992 (###)-##-##-##";
        }
        if (value === "bday") {
          return "##.##.####";
        }
      };
    },
  },
  methods: {
    handleClear() {
      this.inner_value = "";
      this.$emit("input", this.inner_value);
    },
  },
};
</script>

<style lang="scss" scoped>
.t-input {
  width: 100%;
  display: flex;
  align-items: center;
  // border-radius: 12px;
  border: 1px solid #e1e1e6;
  background: #fff;
  input {
    color: #0c63e4;
    width: 100%;
    background: #fff;
    padding: 20px;
  }
  i {
    cursor: pointer;
    padding: 5px 10px;
    transition: all ease 0.3s;
  }
}
</style>
